#include "tnotify.h"
#include "QtGui"
#include "tnotifywindow.h"
#include "iostream"

TNotify::TNotify(QObject *parent) :
    QObject(parent),
    notifyNum(0)
{
}

void TNotify::newNotify(QString Title, QString Text){
    notifyList.append(new TNotifyWindow(Title, arrangeText(Text,300,6), notifyList.count()));
    QObject::connect(notifyList.last(), SIGNAL(requestDelete(TNotifyWindow*)), this, SLOT(deleteNotify(TNotifyWindow*)));
    std::cout << "Notification number: " << notifyList.count() << std::endl;
    notifyNum++;
}

void TNotify::deleteNotify(TNotifyWindow* notify){

    std::cout << "Start moving notifications..." << std::endl;
    std::cout << "Hiding..." << std::endl;
    QPropertyAnimation* hidingAnimation = new QPropertyAnimation(notify, "geometry");
    hidingAnimation->setDuration(300);
    hidingAnimation->setStartValue(notify->geometry());
    hidingAnimation->setEndValue(QRect(notify->x()+notify->width(),notify->y(),  notify->width(), notify->height()));
    hidingAnimation->start();
    QEventLoop hidingloop;
    QObject::connect(hidingAnimation, SIGNAL(finished()), &hidingloop, SLOT(quit()));
    hidingloop.exec();
    //notify->hide();
    notify->close();
    for (int i=notifyList.count()-1; i >=0;  i--){
        if (notifyList.at(i)->isHidden()){
            for (int j=notifyList.count()-1; j >= i+1; j--){
                std::cout << "Moving..." << std::endl;
                QPropertyAnimation* anima = new QPropertyAnimation(notifyList.at(j), "geometry");
                anima->setDuration(300);
                anima->setStartValue(notifyList.at(j)->geometry());
                int newY = notifyList.at(j-1)->y() + notifyList.at(j-1)->height() - notifyList.at(j)->height();
                anima->setEndValue(QRect(notifyList.at(j)->x(),newY,  notifyList.at(j)->width(),notifyList.at(j)->height()));
                anima->start();
                QEventLoop loop;
                QObject::connect(anima, SIGNAL(finished()), &loop, SLOT(quit()));
                loop.exec();
            }
        }
    }
    std::cout << "Erasing..." << std::endl;
    //notify->close();
    notifyList.removeOne(notify);
    std::cout << "Remove done." << std::endl;
}

QString TNotify::arrangeText(QString Text, int MaximumWidth, int MaximumRows){
    QString newText;
    QString tmp;
    QString line;

    QLabel lbl;
    QFontMetrics* fm = new QFontMetrics(lbl.font());
    QRegExp newLineExp("^(.*)$");
    QRegExp wordExp("\\b(\\S+)\\b");

    tmp = Text;
    int linePos =0;
    int i =1;
    std::cout << "Start lining." << std::endl;
    while ((linePos = newLineExp.indexIn(tmp,linePos)) != -1 and i <= MaximumRows){
        std::cout << "Line found." << std::endl;
        line = newLineExp.cap(0);
        int pos =0;
        if (line == fm->elidedText(line, Qt::ElideRight, MaximumWidth)){
            newText.append(line);
        }else{
            while((pos = wordExp.indexIn(line,pos)) != -1 and i <= MaximumRows){
                std::cout << "Found a word \"" << wordExp.cap(1).toStdString() << "\"."  << std::endl;
                if (line.left(pos+wordExp.cap(0).size()) == fm->elidedText(line.left(pos+wordExp.cap(0).size()),Qt::ElideRight, MaximumWidth)){
                    //do nothing -> next loop cicle
                    std::cout << "debug 1" << std::endl;
                    std::cout << "Skipping to next word." << std::endl;
                    pos++;
                }else if(pos != 0){
                    std::cout << "debug 2" << std::endl;
                    if (i < MaximumRows){
                        std::cout << "debug 2.1" << std::endl;
                        newText.append(line.left(pos)).append("\n");
                        line = line.mid(pos);
                        pos = 0;
                        i++;
                    }else if(i = MaximumRows){
                        std::cout << "debug 2.2" << std::endl;
                        newText.append(fm->elidedText(line.left(pos+wordExp.cap(0).size()),Qt::ElideRight, MaximumWidth));
                        i++;
                    }else{
                        std::cout << "debug 2.3" << std::endl;
                        std::cout << "An error has occured!" << std::endl;
                        return 0;
                    }
                }else if(pos == 0){
                    std::cout << "debug 3" << std::endl;
                    if (i < MaximumWidth){
                        std::cout << "debug 3.1" << std::endl;
                        int j;
                        while(line.left(j) == fm->elidedText(line.left(j),Qt::ElideRight, MaximumWidth)){
                            j++;
                        }
                        newText.append(line.left(j-1)).append("\n");
                        line = line.mid(j);
                        i++;
                    }else if(i == MaximumWidth){
                        std::cout << "debug 3.2" << std::endl;
                        newText.append(fm->elidedText(line,Qt::ElideRight, MaximumWidth));
                        i++;
                    }else{
                        std::cout << "debug 3.3" << std::endl;
                        std::cout << "An error has occured!" << std::endl;
                        return 0;
                    }
                }else{
                    std::cout << "debug 4" << std::endl;
                    std::cout << "An error has occured!" << std::endl;
                    return 0;
                }
            }
        }

        i++;
        linePos++;
    }
    return newText;
}
